"""upgrade to usermanagement

Revision ID: 468c7626c4c2
Revises: 2ab761fba36
Create Date: 2015-11-14 12:32:18.241252

"""

# revision identifiers, used by Alembic.
revision = '468c7626c4c2'
down_revision = '2ab761fba36'

from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import mysql

def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.create_table('permission',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.Unicode(length=128), nullable=False),
    sa.Column('created', sa.DateTime(), nullable=False),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('name')
    )
    op.create_table('project',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.Unicode(length=128), nullable=False),
    sa.Column('created', sa.DateTime(), nullable=False),
    sa.Column('status', sa.Integer(), nullable=False),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('name')
    )
    op.create_table('role',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.Unicode(length=128), nullable=False),
    sa.Column('created', sa.DateTime(), nullable=False),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('name')
    )
    op.create_table('workgroup',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.Unicode(length=128), nullable=False),
    sa.Column('created', sa.DateTime(), nullable=False),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('name')
    )
    op.create_table('group_group_assoc',
    sa.Column('status', sa.Integer(), nullable=False),
    sa.Column('parent_group_id', sa.Integer(), nullable=False),
    sa.Column('child_group_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['child_group_id'], ['group.id'], ),
    sa.ForeignKeyConstraint(['parent_group_id'], ['group.id'], ),
    sa.PrimaryKeyConstraint('parent_group_id', 'child_group_id')
    )
    op.create_table('group_manager_association',
    sa.Column('group_id', sa.Integer(), nullable=True),
    sa.Column('user_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['group_id'], ['group.id'], ),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], )
    )
    op.create_table('project_group_assoc',
    sa.Column('project_id', sa.Integer(), nullable=False),
    sa.Column('group_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['group_id'], ['group.id'], ),
    sa.ForeignKeyConstraint(['project_id'], ['project.id'], ),
    sa.PrimaryKeyConstraint('project_id', 'group_id')
    )
    op.create_table('project_group_assoc_role_association',
    sa.Column('project_id', sa.Integer(), nullable=True),
    sa.Column('group_id', sa.Integer(), nullable=True),
    sa.Column('role_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['group_id'], ['group.id'], ),
    sa.ForeignKeyConstraint(['project_id'], ['project.id'], ),
    sa.ForeignKeyConstraint(['role_id'], ['role.id'], )
    )
    op.create_table('project_manager_association',
    sa.Column('project_id', sa.Integer(), nullable=True),
    sa.Column('user_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['project_id'], ['project.id'], ),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], )
    )
    op.create_table('project_user_assoc',
    sa.Column('project_id', sa.Integer(), nullable=False),
    sa.Column('user_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['project_id'], ['project.id'], ),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], ),
    sa.PrimaryKeyConstraint('project_id', 'user_id')
    )
    op.create_table('project_user_assoc_role_association',
    sa.Column('project_id', sa.Integer(), nullable=True),
    sa.Column('user_id', sa.Integer(), nullable=True),
    sa.Column('role_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['project_id'], ['project.id'], ),
    sa.ForeignKeyConstraint(['role_id'], ['role.id'], ),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], )
    )
    op.create_table('role_permission_association',
    sa.Column('role_id', sa.Integer(), nullable=True),
    sa.Column('permission_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['permission_id'], ['permission.id'], ),
    sa.ForeignKeyConstraint(['role_id'], ['role.id'], )
    )
    op.create_table('workgroup_manager_association',
    sa.Column('workgroup_id', sa.Integer(), nullable=True),
    sa.Column('user_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], ),
    sa.ForeignKeyConstraint(['workgroup_id'], ['workgroup.id'], )
    )
    op.create_table('workgroup_user_association',
    sa.Column('workgroup_id', sa.Integer(), nullable=True),
    sa.Column('user_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], ),
    sa.ForeignKeyConstraint(['workgroup_id'], ['workgroup.id'], )
    )
    op.add_column(u'group', sa.Column('password', sa.UnicodeText(), nullable=True))
    op.add_column(u'group', sa.Column('privacy', sa.Integer(), nullable=False))
    op.add_column(u'group', sa.Column('status', sa.Integer(), nullable=False))
    op.add_column(u'user', sa.Column('serveradmin', sa.Boolean(), nullable=False))
    ### end Alembic commands ###

    # rename grouplist, add column, set constraints
    op.rename_table('grouplist', 'group_user_assoc')
    op.add_column(u'group_user_assoc', sa.Column('status', sa.Integer(), nullable=False))
    op.drop_constraint('group_user_assoc_ibfk_1', 'group_user_assoc', type_='foreignkey')
    op.drop_constraint('group_user_assoc_ibfk_2', 'group_user_assoc', type_='foreignkey')
    op.drop_index('group_id', 'group_user_assoc')
    op.create_primary_key(None, 'group_user_assoc', ['group_id', 'user_id'])
    op.create_foreign_key('group_user_assoc_ibfk_1', 'group_user_assoc', 'group', ['group_id'], ['id'])
    op.create_foreign_key('group_user_assoc_ibfk_2', 'group_user_assoc', 'user', ['user_id'], ['id'])
    # set default values
    # group
    group_password_column = sa.sql.table('group', sa.sql.column('password'))
    group_privacy_column = sa.sql.table('group', sa.sql.column('privacy'))
    group_status_column = sa.sql.table('group', sa.sql.column('status'))
    op.execute(group_password_column.update().values(password=None))
    op.execute(group_privacy_column.update().values(privacy=0))
    op.execute(group_status_column.update().values(status=1))
    # user
    user_serveradmin_column = sa.sql.table('user', sa.sql.column('serveradmin'))
    op.execute(user_serveradmin_column.update().values(serveradmin=False))
    # group_user_assoc
    group_user_assoc_status_column = sa.sql.table('group_user_assoc', sa.sql.column('status'))
    op.execute(group_user_assoc_status_column.update().values(status=0))


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.drop_column(u'user', 'serveradmin')
    op.drop_column(u'group', 'status')
    op.drop_column(u'group', 'privacy')
    op.drop_column(u'group', 'password')
    op.drop_table('workgroup_user_association')
    op.drop_table('workgroup_manager_association')
    op.drop_table('role_permission_association')
    op.drop_table('project_user_assoc_role_association')
    op.drop_table('project_user_assoc')
    op.drop_table('project_manager_association')
    op.drop_table('project_group_assoc_role_association')
    op.drop_table('project_group_assoc')
    op.drop_table('group_manager_association')
    op.drop_table('group_group_assoc')
    op.drop_table('workgroup')
    op.drop_table('role')
    op.drop_table('project')
    op.drop_table('permission')
    ### end Alembic commands ###

    # rename group_user_assoc, drop columns, set constrains
    op.rename_table('group_user_assoc', 'grouplist')
    op.drop_column(u'grouplist', 'status')
    op.drop_constraint('grouplist_ibfk_1', 'grouplist', type_='foreignkey')
    op.drop_constraint('grouplist_ibfk_2', 'grouplist', type_='foreignkey')
    op.create_index('group_id', 'grouplist', ['group_id'])
    op.drop_constraint('PRIMARY', 'grouplist', type_='primary')
    op.create_foreign_key('grouplist_ibfk_1', 'grouplist', 'group', ['group_id'], ['id'])
    op.create_foreign_key('grouplist_ibfk_2', 'grouplist', 'user', ['user_id'], ['id'])
